# -*- coding: utf-8 -*-

#  PyKompasMacro https://slaviationsoft.blogspot.com
#  КОМПАС-3D (23, 0, 6, 0)
#  PyKompasMacro.exe (1.7.57.116)

import pythoncom
from win32com.client import Dispatch, gencache, VARIANT

#  Получи константы
kompas6_constants = gencache.EnsureModule("{75C9F5D0-B5B8-4526-8681-9903C567D2ED}", 0, 1, 0).constants
kompas6_constants_3d = gencache.EnsureModule("{2CAF168C-7961-4B90-9DA2-701419BEEFE3}", 0, 1, 0).constants

#  Получи API интерфейсов версии 5
kompas6_api5_module = gencache.EnsureModule("{0422828C-F174-495E-AC5D-D31014DBBE87}", 0, 1, 0)
kompas_object = kompas6_api5_module.KompasObject(Dispatch("Kompas.Application.5")._oleobj_.QueryInterface(kompas6_api5_module.KompasObject.CLSID, pythoncom.IID_IDispatch))

#  Получи API интерфейсов версии 7
kompas_api7_module = gencache.EnsureModule("{69AC2981-37C0-4379-84FD-5DD2F3C0A520}", 0, 1, 0)
kompas_api_object = kompas_api7_module.IKompasAPIObject(Dispatch("Kompas.Application.7")._oleobj_.QueryInterface(kompas_api7_module.IKompasAPIObject.CLSID, pythoncom.IID_IDispatch))
application = kompas_api_object.Application

#  Получи интерфейс активного документа
kompas_document = application.ActiveDocument

#  Сохрани документ в PDF
converter = application.Converter("C:\\Program Files\\ASCON\\KOMPAS-3D v23\\Bin\\Pdf2d.dll")
converter_parameters_module = gencache.EnsureModule("{31EBF650-BD38-43EC-892B-1F8AC6C14430}", 0, 1, 0)
converter_parameters = converter_parameters_module.IPdf2dParam(converter.ConverterParameters(0)._oleobj_.QueryInterface(converter_parameters_module.IPdf2dParam.CLSID, pythoncom.IID_IDispatch))
converter_parameters.ColorType = 3
converter_parameters.CutByFormat = True
converter_parameters.DrawQuality = 50
converter_parameters.EmbedFonts = True
converter_parameters.FilterDisable = False
converter_parameters.FilterFlags = 59167
converter_parameters.FilterStyles = 256
converter_parameters.GrayScale = False
converter_parameters.HeightUserSheet = 297.0
converter_parameters.HorizontOrientation = False
converter_parameters.ISOid = 4
converter_parameters.MultiPageOutput = True
converter_parameters.MultipleFormat = 1
converter_parameters.OnlyThinLine = False
converter_parameters.PageOddEven = 0
converter_parameters.PageRange = 0
converter_parameters.PageRangeStr = ""
converter_parameters.Resolution = 300
converter_parameters.Scale = 0.5
converter_parameters.UserFormat = False
converter_parameters.WidthUserSheet = 210.0
converter.Convert("C:\\КОМПАС\\Деталь _ АБВГД.cdw", "C:\\КОМПАС\\Деталь _ АБВГД.pdf", 0, False)
